Index: contrib/slime-parse.el
===================================================================
RCS file: /project/slime/cvsroot/slime/contrib/slime-parse.el,v
retrieving revision 1.19
diff -u -r1.19 slime-parse.el
--- contrib/slime-parse.el	27 Feb 2009 21:35:35 -0000	1.19
+++ contrib/slime-parse.el	28 Apr 2009 12:59:31 -0000
@@ -30,29 +30,21 @@
   "Returns the sexps at point as a list of strings, otherwise nil.
 \(If there are not as many sexps as N, a list with < N sexps is
 returned.\) 
-If SKIP-BLANKS-P is true, leading whitespaces &c are skipped.
-"
-  (interactive "p") (or n (setq n 1))
-  (flet ((sexp-at-point (first-choice)
-           (let ((string (if (eq first-choice :symbol-first)
-                             (or (slime-symbol-at-point)
-                                 (thing-at-point 'sexp))
-                             (or (thing-at-point 'sexp)
-                                 (slime-symbol-at-point)))))
-             (if string (substring-no-properties string) nil))))
-    (save-excursion
-      (when skip-blanks-p ; e.g. `( foo bat)' where point is after ?\(.
-        (slime-forward-blanks))
-      (let ((result nil))
-        (dotimes (i n)
-          (push (slime-sexp-at-point) result)
-          ;; Skip current sexp
-          (ignore-errors (forward-sexp) (slime-forward-blanks))
-          ;; Is there an additional sexp in front of us?
-          (save-excursion
-            (unless (slime-point-moves-p (ignore-errors (forward-sexp)))
-              (return))))
-        (nreverse result)))))
+If SKIP-BLANKS-P is true, leading whitespaces &c are skipped."
+  (interactive "p")
+  (save-excursion
+    (when skip-blanks-p                 ; e.g. `( foo bat)' where point is after ?\(.
+      (slime-forward-blanks))
+    (let ((result nil))
+      (dotimes (i (or n 1))
+        (push (slime-sexp-at-point) result)
+        ;; Skip current sexp
+        (ignore-errors (forward-sexp) (slime-forward-blanks))
+        ;; Is there an additional sexp in front of us?
+        (save-excursion
+          (unless (slime-point-moves-p (ignore-errors (forward-sexp)))
+            (return))))
+      (nreverse result))))
 
 (defun slime-has-symbol-syntax-p (string)
   (if (and string (not (zerop (length string))))
@@ -196,6 +188,9 @@
 	   ;; Do NEVER ever try to activate `lisp-mode' here with
 	   ;; `slime-use-autodoc-mode' enabled, as this function is used
 	   ;; to compute the current autodoc itself.
+
+           ;; without this (thing-at-point 'sexp) doesn't work on 'foo or #foo
+           (set-syntax-table lisp-mode-syntax-table)
 	   (erase-buffer)
 	   (insert string)
 	   (when strip-operator-p ; `(OP arg1 arg2 ...)' ==> `(arg1 arg2 ...)'
